# xqq

> Lightweight Promise-based request library for Node powered by phin

[![xqq on NPM](https://nodei.co/npm/xqq.png)](https://www.npmjs.com/package/xqq)

[![xqq - Downloads Total](https://img.shields.io/npm/dt/xqq.svg)](https://www.npmjs.com/package/xqq) [![xqq - Version](https://img.shields.io/npm/v/xqq.svg)](https://www.npmjs.com/package/xqq) [![xqq - License](https://img.shields.io/npm/l/xqq.svg)](https://www.npmjs.com/package/xqq) [![xqq - Github Stars](https://img.shields.io/github/stars/FuturisticCake/xqq.svg?style=social&label=Star)](https://github.com/FuturisticCake/xqq)

---

## Usage - POST request with data

```javascript
const xqq = require("xqq");

xqq({
    "url": "https://example.com/api",
    "method": "POST",
    "data": {
        "hey": "there"
    }
}).then((res) => {
    console.log("Response body: "+res.body);
}, (err) => {
    console.log("Uh oh... Error: " + err);
});
```

## Installation

```
npm install xqq
```

## Demonstration - Basic GET request

```javascript
xqq("https://example.com").then((res) => {
    console.log("Got body! " + res.body)
}, (err) => {
    console.log("Request failed! "+err);
});
```

# API

A full list of request options can be found at [phin API documentation](https://www.npmjs.com/package/phin#api).
Response object is an HTTP / HTTPS response object. See [Node.JS HTTP docs - HTTP.serverResponse class](https://nodejs.org/dist/latest-v7.x/docs/api/http.html#http_class_http_serverresponse).

## License (MIT)

Copyright (c) 2017 Ethan Davis

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
